#version 3.7;//.0.RC4-2(pacman) //Created with this version.

#include "colors.inc"
#include "functions.inc"

global_settings
{ assumed_gamma 1.0
  radiosity {
    pretrace_start 0.08
    pretrace_end   0.01
    count 150
    nearest_count 10
    error_bound 0.5
    recursion_limit 3
    low_error_factor 0.5
    gray_threshold 0.0
    minimum_reuse 0.005
    maximum_reuse 0.2
    brightness 1
    adc_bailout 0.005
  }
}

camera{
  location <17,0,10>
  look_at 0
  angle 7
  up <0,0,1>
  right <1,0,0>
}
light_source{ <1000*sin(clock), 0, 1000*cos(clock)> White }

#declare hmap = function{ pigment {
  image_map {
    png "tex/1/hm.bmp.png"
    map_type 0
    interpolate 0
  }}}

sphere { <0,0,0>, 1
  texture {
    uv_mapping
    pigment{ image_map{
	png "tex/1/tex.bmp.png"
	map_type 0
	interpolate 0
    }}
    normal{ function{ hmap(x,y,z).red } }
  }
}

#declare surf_dist = function(x,y,z)
{ sqrt(x*x+y*y+z*z)-1 }
#declare atm_h = 0.05;
#declare cloud_h = 0.5*atm_h;

#declare air =
      media {
	absorption rgb<0,0.5,0.6> //Lower these
	scattering{1, rgb<0.3,0.3,0.8>}
	density {
	  function{exp(-surf_dist(x,y,z)/(3*atm_h))}
	  color_map {
	    [0.0 color rgb <0,0,0>]
	    [1.0 color rgb <1,1,1>] } }} //less R

//Air!
sphere{ <0,0,0> 1
  hollow 
  pigment{ Clear }
  interior{ media{air} }
  scale 1+atm_h
}

#declare GRANITE = function
  { pigment{ granite
             color_map { [0.0 color rgb <0, 0, 0>]
	                 [1.0 color rgb <1, 1, 1>] }} }
    
#declare angle_time = function(x,y,z)
  { f_noise3d(2*x,2*(y+ 2*cos(clock)),2*(z+ 2*sin(clock))) }
  
//This 'flows' planet-scale i want 'dynamics'
#declare cloud_comb = function(x,y,z) 
  { GRANITE(x, y + 2*sin(angle_time(x,y,z)), 
            z + 2*cos(angle_time(x,y,z))).red * f_noise3d(x,y,z) }
  
//Thanks to http://geomorph.sourceforge.net
#declare CLOUDS = 
  pigment {
    function{ cloud_comb(x,y,z) }
    warp{ turbulence 0.2+0.05*cos(clock) }
    color_map {
      [0.2  rgbt <1,1,1,1>]
      [0.95 rgbt <1,1,1,0.3>] // Sudbued blueish white
      [1.0  rgbt <1,1,1,0.3>]
    }
  }
  
#declare SMALLER_CLOUDS =
  pigment {
    function{ cloud_comb(x,y,z) }
    warp{ turbulence 0.2+0.05*cos(clock) }
    color_map {
      [0.4  rgbt <1,1,1,1>] 
      [0.95 rgbt <1,1,1,0.3>]
      [1.0  rgbt <1,1,1,0.3>]
    }
  }

sphere //Clouds(1)
  { <0,0,0>, 1+atm_h*0.2
    //Temporary in order to develop the terrain,
    //pigment{color red 0.8 green 0.8 blue 1  transmit 0.9 }
    pigment{ CLOUDS }
  }
  
  
sphere //Clouds(2)
  { <0,0,0>, 1+atm_h*0.3
    pigment{ SMALLER_CLOUDS }
  }
 